//enum EAppliesToEvent
var kateAgnostic=-1;
var kateOnReceive=0;
var kateOnSend=1;

//enum ESystemEvent 
var kseOnReceive=0;
var kseOnSend=1;


var	oRules = window.external.getRules();

function oSessionRule() {
	var oRule = window.external.getSessionRule();
	return oRule;
}

function getDigits(s) {
	var id = 0;
	var re = /\d+/i;
	var sRet = "";
	sRet = s.match(re);
	if (sRet.length)
		id = sRet;
	return id;	
}

function conditionDetails(oconds, et) {
	if (oconds.count ==	0) {
		return;
	}
	
	var	s, econds, ocond, id, fFirst;
	oconds = new Enumerator(oconds);
	fFirst = new Boolean(true);
	s =	new	String("");

	for	(;!oconds.atEnd();oconds.moveNext()) {
		ocond =	oconds.item();
		id = ocond.id;
		
		s = s + "<LI type=circle>";
		s =	s +	ocond.preLink;

		var	stemp;
		stemp =	new	String(ocond.link);
		if (stemp.length > 0)
			s =	s +	'&nbsp;<a href="#" onclick="' + 
			    ((0==et)? 'condition_link_onclick(': 'exception_link_onclick(') + id + ')">'	+ stemp	+ '</a>';
		
		stemp =	new	String(ocond.postLink);
		if (stemp.length > 0)
			s =	s +	'&nbsp;' + stemp;
	}

	return s;
}

function actionDetails(oconds) {
	if (oconds.count ==	0) {
		return;
	}
	
	var	s, econds, ocond, id, fFirst;
	oconds = new Enumerator(oconds);
	fFirst = new Boolean(true);
	s =	new	String("");

	for	(;!oconds.atEnd();oconds.moveNext()) {
		ocond =	oconds.item();
		id = ocond.id;
		
		s = s + "<LI type=circle>";
		s =	s +	ocond.preLink;

		var	stemp;
		stemp =	new	String(ocond.link);
		if (stemp.length > 0)
			s =	s +	'&nbsp;<a href="#" onclick="action_link_onclick(' + id + ')">'	+ stemp	+ '</a>';
		
		stemp =	new	String(ocond.postLink);
		if (stemp.length > 0)
			s =	s +	'&nbsp;' + stemp;
	}

	return s;
}

function ruleDetails(oRule) {
	//var oRule; 	
	/*if (ruleID>0) 
		// rules listing, not modifying rule
		oRule = oRules.item(ruleID);
	else 
		oRule = window.external.getSessionRule();*/
		
	var	s =	new	String("<B>");

	if (0 == oRule.applyOn)	{
		s =	s + "When an incoming message arrives:";
	}
	else if (1 == oRule.applyOn)	{
		s =	s + "When a message is sent:";
	}
	else {
		s =	s + "When an incoming message arrives or a message is sent:";
	}
		
	s =	s +	"</B><BR>";

	var	oconds = oRule.conditions;
	if (oconds.count == 0)
        s = s + "";
		//s = s +	"<I>Please select at least one condition for this rule.</I><BR>";
	else
		s =	s +	conditionDetails(oconds,0);
	
	s =	s + "<BR><BR><B>Perform the following actions:</B><BR>";

	var	oactions = oRule.actions;
	if (oactions.count == 0)
		s = s +	"<I>Please select at least one action for this rule.</I><BR>";
	else
		s =	s +	actionDetails(oactions);

	var	oexceptions = oRule.exceptions;
	if (oexceptions.count > 0) {
		s =	s + "<BR><BR><B>Except when:</B><BR>";
		s =	s +	conditionDetails(oexceptions,2);
    }
    
	return s;
}

function ShowDetails(oRule) {
	document.all("ruleDetails").innerHTML = ruleDetails(oRule);
}

function exception_link_onclick(id) {
	// get oRule from getSessionRule() or from oRules if you are in the rulesList
	oRule = oSessionRule();
	if (typeof(oRule) == "undefined") {
		oRules = window.external.getRules();
		oRule =	oRules.item(getDigits(selectedRow.id));
	}
  
  var ocond = oRule.exceptions.item(id);
  ocond.launchSelector();
  
  // update rules list
    if (typeof(selectedRow) != "undefined") {
        if (oRule.isValid)
            loadRules();
    }
    // update rule descriptions
    ShowDetails(oRule);
}

function condition_link_onclick(id) {
	// get oRule from getSessionRule() or from oRules if you are in the rulesList
	oRule = oSessionRule();
	if (typeof(oRule) == "undefined") {
		oRules = window.external.getRules();
		oRule =	oRules.item(getDigits(selectedRow.id));
	}
  
    var ocond = oRule.conditions.item(id);
    ocond.launchSelector();

    // using selectedRow as an indicator of whether of not we are on the rules list page
    if (typeof(selectedRow) != "undefined") {
        if (oRule.isValid)
            loadRules();
    }
    // update rule descriptions
    ShowDetails(oRule);
}

function action_link_onclick(id) {
	// get oRule from getSessionRule() or from oRules if you are in the rulesList
	oRule = oSessionRule();
	if (typeof(oRule) == "undefined") {
		oRules = window.external.getRules();
		oRule =	oRules.item(getDigits(selectedRow.id));
	}
  
    var ocond = oRule.actions.item(id);
    ocond.launchSelector();
  
    // using selectedRow as an indicator of whether of not we are on the rules list page
    if (typeof(selectedRow) != "undefined") {
        if (oRule.isValid)
            loadRules();
    }
    // update rule descriptions
    ShowDetails(oRule);
}

function btn_done_onclick() {
	oRule = oSessionRule();
    if (0==oRule.actions.count) {
        alert("Invalid rule. A rule must have at least one valid action.");
        return;
    }
    if (0==oRule.conditions.count && 0==oRule.exceptions.count) {
        var sPrompt = "This rule will be applied to every message you ";
        if (kseOnReceive==oRule.applyOn) {
            sPrompt += "receive";
        }
        else {
            sPrompt += "send";
        }
        sPrompt += ". Is this correct?"
        if (!window.external.promptQ(sPrompt))
            return;
    }
    if (!oRule.isValid) {
        alert("Invalid rule. All conditions and actions must be valid.");
        return;
    }
    var fUnique = true;
    var sName = oRule.name;
    var sNameLC = sName.toLowerCase();
    var id = oRule.id;
	var	erules, oRulesT, oRuleT;
    oRulesT = window.external.getRules();
	erules = new Enumerator(oRulesT);
	for	(;!erules.atEnd();erules.moveNext()) {
		oRuleT = erules.item();
        if (sNameLC == oRuleT.name.toLowerCase() && id != oRuleT.id) {
            fUnique = false;
        }
	}
    if (!fUnique) {
        alert("A rule with the name '" + sName + "' already exists. Please enter a different name.");
        window.navigate('setup.html');
        return;
    }
    if (oRule.clientOnly) {
        alert("This rule is being saved as a client-only rule, and will process only when Outlook is running.");
    }
    if (!window.external.saveSessionRule()) {
        alert("Failed to save changes.");
    }
    window.navigate('rulesList.htm');
}
